var cm = require("sdk/context-menu");
var panels = require("panel");
var selection = require("sdk/selection");
var self = require("self");
var tabs = require("sdk/tabs");
var widgets = require("sdk/widget");

var selectedText;

function selectionChanged(event) {
  selectedText = selection.text;
}

selection.on("select", selectionChanged);

function openArticle() {
  console.log(selectedText);
  tabs.open("http://de.wikipedia.org/w/index.php?search=" + selectedText);
}

function openArticleInPanel() {
  panel.port.emit("loadPage", "http://de.m.wikipedia.org/w/index.php?search=" + selectedText);
}

cm.Item({
  label: "Wikipediaartikel aufrufen",
  context: cm.SelectionContext(),
  contentScript: 'self.on("click", self.postMessage);',
  onMessage: openArticle
});

var panel = panels.Panel ({
  contentURL: self.data.url("panel.html"),
  contentScriptFile: self.data.url("panel.js"),
  onHide: function () {
    panel.port.emit("loadPage", "about:blank");
  },
  width: 450,
  heigth: 450
});

panel.port.on("closePanel", function() {
  panel.hide();
});

var widget = widgets.Widget({
  id: 'wikipedia-icon',
  label: 'Wikipedia',
  content: '<b style="font-family:Times">W</b>',
  panel: panel,
  onClick: openArticleInPanel
});
